#ifndef __AT_SPI_FLASH_H
#define __AT_SPI_FLASH_H
#include "at32f403a_407_board.h"

#define FLASH_SPI                   SPI3
#define FLASH_SPI_CLOCK             CRM_SPI3_PERIPH_CLOCK

/*SCK Pin*/
#define FLASH_SPI_SCK_PIN           GPIO_PINS_3
#define FLASH_SPI_SCK_GPIO          GPIOB
#define FLASH_SPI_SCK_GPIO_CLOCK    CRM_GPIOB_PERIPH_CLOCK

/*MISO Pin*/
#define FLASH_SPI_MISO_PIN          GPIO_PINS_4
#define FLASH_SPI_MISO_GPIO         GPIOB
#define FLASH_SPI_MISO_GPIO_CLOCK   CRM_GPIOB_PERIPH_CLOCK

/*MOSI Pin*/
#define FLASH_SPI_MOSI_PIN          GPIO_PINS_5
#define FLASH_SPI_MOSI_GPIO         GPIOB
#define FLASH_SPI_MOSI_GPIO_CLOCK   CRM_GPIOB_PERIPH_CLOCK

/*CS Pin*/
#define FLASH_SPI_CS_PIN            GPIO_PINS_15
#define FLASH_SPI_CS_GPIO           GPIOA
#define FLASH_SPI_CS_GPIO_CLOCK     CRM_GPIOA_PERIPH_CLOCK

/*FLASH instruction, ͬFLASH ָͬ,ĿǰΪDemo Flash ͺΪW25Q128FV */
#define  FLASH_GETID              0x90
#define  FLASH_CMD_WREN           0x06  /*!< Write enable instruction */
#define  FLASH_CMD_ERASE_SECTOR	  0x20  /*!< Sector Erase instruction */
#define  FLASH_CMD_READSTS	      0x05  /*!< Read Status Register instruction */
#define  FLASH_CMD_WRITEPAGE	    0x02  /*!< Program Page Register instruction */
#define  FLASH_CMD_READPAGE	      0x03  /*!< Read Page Register instruction */


uint32_t flash_spi_init(void);
uint32_t flash_spi_write(uint8_t* pbuffer, uint32_t writeaddr, uint16_t numbytetowrite);
uint32_t flash_spi_read(uint8_t* pbuffer, uint32_t readaddr, uint16_t numbytetoread);
uint32_t flash_spi_getsize(void);
uint32_t flash_spi_sectorsize(void);
uint32_t flash_spi_pagesize(void);
uint32_t flash_spi_getid(void);


#endif


